#pragma once

#include <iostream>
#include <vector>
#include <fstream>
#define _USE_MATH_DEFINES
#include <math.h>
#include <Windows.h>
#include "ref.h"
#include <inttypes.h>
#include <stdarg.h>

using std::string;
using std::vector;
typedef uint8_t byte;
typedef int16_t sample;

static string csprintf(const char* format, ...) {
    va_list args;
    va_start(args, format);
    size_t requiredChars = vsnprintf(nullptr, 0, format, args);
    va_start(args, format);
    char* buffer = new char[requiredChars + 1];
    vsnprintf(buffer, requiredChars + 1, format, args);
    buffer[requiredChars] = 0;
    return string(buffer);
}
